VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsComPort"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'     COM-
Private Const GENERIC_READ As Long = &H80000000
Private Const GENERIC_WRITE As Long = &H40000000
Private Const OPEN_EXISTING As Long = 3
Private Const FILE_ATTRIBUTE_NORMAL As Long = &H80
Private Const FILE_FLAG_OVERLAPPED = &H40000000
Private Const INVALID_HANDLE_VALUE As Long = -1
Private Const EV_RXCHAR As Long = &H1
Private Const ERROR_IO_PENDING As Long = 997
Private Const INFINITE As Long = &HFFFFFFFF

'    
Private Type OVERLAPPED
    Internal As Long
    InternalHigh As Long
    Offset As Long
    OffsetHigh As Long
    hEvent As Long
End Type

' API-
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" ( _
    ByVal lpFileName As String, _
    ByVal dwDesiredAccess As Long, _
    ByVal dwShareMode As Long, _
    ByVal lpSecurityAttributes As Long, _
    ByVal dwCreationDisposition As Long, _
    ByVal dwFlagsAndAttributes As Long, _
    ByVal hTemplateFile As Long) As Long

Private Declare Function CloseHandle Lib "kernel32" ( _
    ByVal hObject As Long) As Long

Private Declare Function WriteFile Lib "kernel32" ( _
    ByVal hFile As Long, _
    ByVal lpBuffer As String, _
    ByVal nNumberOfBytesToWrite As Long, _
    ByRef lpNumberOfBytesWritten As Long, _
    ByVal lpOverlapped As Long) As Long

Private Declare Function ReadFile Lib "kernel32" ( _
    ByVal hFile As Long, _
    ByVal lpBuffer As String, _
    ByVal nNumberOfBytesToRead As Long, _
    ByRef lpNumberOfBytesRead As Long, _
    ByVal lpOverlapped As Long) As Long

Private Declare Function SetCommMask Lib "kernel32" ( _
    ByVal hFile As Long, _
    ByVal dwEvtMask As Long) As Long

Private Declare Function WaitCommEvent Lib "kernel32" ( _
    ByVal hFile As Long, _
    ByRef lpEvtMask As Long, _
    ByVal lpOverlapped As Long) As Long

Private Declare Function CreateEvent Lib "kernel32" Alias "CreateEventA" ( _
    ByVal lpEventAttributes As Long, _
    ByVal bManualReset As Long, _
    ByVal bInitialState As Long, _
    ByVal lpName As String) As Long

Private Declare Function ResetEvent Lib "kernel32" ( _
    ByVal hEvent As Long) As Long

Private Declare Function WaitForSingleObject Lib "kernel32" ( _
    ByVal hHandle As Long, _
    ByVal dwMilliseconds As Long) As Long

'  
Private hPort As Long
Private hEvent As Long
Private ov As OVERLAPPED

'  DataReady
Public Event DataReady()

'  COM-
Public Function OpenPort(ByVal PortName As String, ByVal BaudRate As Long) As Boolean
    If hPort <> 0 Then ClosePort
    
    hPort = CreateFile(PortName, GENERIC_READ Or GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)
    
    If hPort = INVALID_HANDLE_VALUE Then
        hPort = 0
        OpenPort = False
        Exit Function
    End If
    
    '     
    hEvent = CreateEvent(0, 1, 0, "")
    ov.hEvent = hEvent
    
    '   
    SetCommMask hPort, EV_RXCHAR
    
    OpenPort = True
End Function

'  COM-
Public Sub ClosePort()
    If hPort <> 0 Then
        CloseHandle hPort
        hPort = 0
    End If
    If hEvent <> 0 Then
        CloseHandle hEvent
        hEvent = 0
    End If
End Sub

'    
Public Function WriteData(ByVal Data As String) As Boolean
    Dim BytesWritten As Long
    WriteFile hPort, Data, Len(Data), BytesWritten, 0
    WriteData = (BytesWritten = Len(Data))
End Function

'    
Public Function ReadData(ByRef Data As String) As Boolean
    Dim Buffer As String * 1024
    Dim BytesRead As Long
    
    '   
    If WaitCommEvent(hPort, 0, VarPtr(ov)) = 0 Then
        If Err.LastDllError <> ERROR_IO_PENDING Then
            ReadData = False
            Exit Function
        End If
    End If
    
    '   
    WaitForSingleObject hEvent, INFINITE
    ResetEvent hEvent
    
    '  
    ReadFile hPort, Buffer, Len(Buffer), BytesRead, VarPtr(ov)
    Data = Left$(Buffer, BytesRead)
    
    ReadData = True
End Function

'   (   )
Public Sub CheckEvents()
    Dim Mask As Long
    If WaitCommEvent(hPort, Mask, VarPtr(ov)) = 0 Then
        If Err.LastDllError = ERROR_IO_PENDING Then
            WaitForSingleObject hEvent, INFINITE
            ResetEvent hEvent
        End If
    End If
    
    If (Mask And EV_RXCHAR) Then
        RaiseEvent DataReady
    End If
End Sub
